int freeRam(void)
{
  extern int  __bss_end; 
  extern int  *__brkval; 
  int free_memory; 
  if((int)__brkval == 0) {
    free_memory = ((int)&free_memory) - ((int)&__bss_end); 
  }
  else {
    free_memory = ((int)&free_memory) - ((int)__brkval); 
  }
  return free_memory; 
} 

int modifyvlalue(int value, byte x, byte y, byte w, int minvalue, int maxvalue, byte increment)
{
  char line[10];
  
  boolean encpressed = true;
  boolean do_not_exit_sub_menu = true;
  unsigned long lastpress = millis();
  
  byte wpx = w * 6 + 2 * 2 + 2 * 2 - 1; // 5 pixels + 1 space by char * num char + 2 pix border x 2 + 2 pix empty border x 2 - 1 not needed space
  byte hpx = 7 + 2 * 2 + 2 * 2;
  y = y - 4;

  tft.drawborder(x,y,x+wpx,y+hpx,2,ST7735_BLACK,fgcolor);
  
  sprintf(line,"%%0%dd",w);
  sprintf(line,line,value);
  
  tft.drawstring(x+4,y+4,line,fgcolor,1,false); 
  
  while (do_not_exit_sub_menu)
  {
    encpressed = ((digitalRead(EncPress) == LOW) &&
                  (! encpressed) && 
                  ((millis() - lastpress)>DeBounce));

    if (encpressed)
    {
      while (digitalRead(EncPress) == LOW)
      {
      }
      lastpress = millis();      
      lastmove = lastpress;

      do_not_exit_sub_menu = false;
    }
    else
    if (EncoderDiff != 0)
    {
      lastmove = millis();
      
      if (EncoderDiff == -1)
      {
        if (value <= (maxvalue-increment))
        {
          value += increment;
        }
        else
        {
          value = minvalue;
        }
      }
      if (EncoderDiff == 1)
      {
        if (value >= (minvalue+increment))
        {
          value -= increment;
        }
        else
        {
          value = maxvalue;
        }
      }      
      
      EncoderDiff = 0;
      
      //tft.fillRect(x+2,y+2,wpx-4,hpx-4,ST7735_BLACK);
      
      sprintf(line,"%%0%dd",w);
      sprintf(line,line,value);
      
      tft.drawstring(x+4,y+4,line,fgcolor,1,false); 

    }
    
  }
  
  return value;
}

void drawfleche(byte menupos, byte x, byte ymin, byte ymax)
{
  char leclerc;
  
  for (byte i=ymin;i<=ymax;i+=8)
  {
    if (menupos == (i-ymin) / 8)
    {
      leclerc = ARRCHAR;
    }
    else
    {
      leclerc = DOTCHAR;
    }
    tft.drawchar(x,i,leclerc,fgcolor,1,false);
  }   
}

void ms2hmsms(unsigned long ms, byte &h, byte &m, byte &s, int &n)
{
  n = ms % 1000;
  ms /= 1000;
  s = ms % 60;
  ms /= 60;
  m = ms % 60;
  ms /= 60;
  h = ms;
}

unsigned long hmsms2ms(byte h, byte m, byte s, int ms)
{
  unsigned long r = (unsigned int)h*60;
  r = (r+(unsigned long)m)*60;
  r = (r+(unsigned long)s)*1000;
  r = r +(unsigned long)ms; 
  return r;
}

void checkveille()
{
  unsigned long ms = (((unsigned long)LCD_veille_minute*60+(unsigned long)LCD_veille_seconde)*1000);
  
  if (ms == 0)
  {
    ms = millis();
  }

  if ((millis()-lastmove) > ms)
  {
    if (! veille_active)
    {
      analogWrite(BacklightPWM,0);
      veille_active = true;
    }
  }     
  else
  {
    if (veille_active)
    {
      analogWrite(BacklightPWM,LCD_lumi);
      veille_active = false;
    }
  }     
}

void waitatend()
{
  int i = 0;
  int j = 1;
  int c = 1;
  
  while (true)
  {
    if (EncoderDiff != 0)
    {
      lastmove = millis();
      EncoderDiff = 0;
    }    

    checkveille();      
    
    //analogWrite(EncGRN,i);
    //analogWrite(EncBLU,i);
    analogWrite(EncRED,i);
    
    if (c < 2)
      digitalWrite(buzzer,HIGH);
    
    if (digitalRead(EncPress) == LOW)
    {
      lastmove = millis();
      lastpress = lastmove;
      checkveille();      
      while (digitalRead(EncPress) == LOW)
      {
      }
      digitalWrite(EncRED,LOW);
      digitalWrite(EncGRN,LOW);
      digitalWrite(EncBLU,LOW);
      return;
    }

    i += j;
    delayMicroseconds(500-i);
    digitalWrite(buzzer,LOW);
    if (i>254)
    {
      j = -1;
      c += 1;
      if (c >= 3)
      {
        c = 1;
      }
    }  
    if (i<1)
    {
      j = 1;
    }  
  }  
}

void DisplayMs(unsigned long msvalue,byte x, byte y, uint16_t textcolor=ST7735_WHITE, boolean transprent=true)
{
  byte c_heure, c_minute, c_seconde;
  int c_milliseconde;
  char line[13];
  ms2hmsms(msvalue,c_heure,c_minute,c_seconde,c_milliseconde);
  sprintf(line,"%02d:%02d:%02d.%03d",c_heure,c_minute,c_seconde,c_milliseconde);
  tft.drawstring(x,y,line,textcolor,1,transprent);  
}
