void Read_EEPROM()               // Lecture des parametres depuis l'EEPROM
{  
  EC_mode                    = EEPROM.read(    1);
  EC_delais                  = Read_EEPROMint( 2);
  EC_duree_heure             = EEPROM.read(    4);
  EC_duree_minute            = EEPROM.read(    5);
  EC_duree_seconde           = EEPROM.read(    6);
  EC_duree_milliseconde      = Read_EEPROMint( 7);
  EC_increment_heure         = EEPROM.read(    9);
  EC_increment_minute        = EEPROM.read(   10);
  EC_increment_seconde       = EEPROM.read(   11);
  EC_increment_milliseconde  = Read_EEPROMint(12);
  EC_intervalle_heure        = EEPROM.read(   14);
  EC_intervalle_minute       = EEPROM.read(   15);
  EC_intervalle_seconde      = EEPROM.read(   16);
  EC_intervalle_milliseconde = Read_EEPROMint(17);
  EC_nombre                  = Read_EEPROMint(19);
  LCD_jour                   = EEPROM.read(   23);
  LCD_lumi                   = EEPROM.read(   24);
  LCD_veille_minute          = EEPROM.read(   25);
  LCD_veille_seconde         = EEPROM.read(   26);
  SLR_prefocus               = EEPROM.read(   27);
  SLR_pause_mini_milliseconde = Read_EEPROMint(28);
  SLR_verr_mirroir           = EEPROM.read(   30);  
}

int Read_EEPROMint(byte lsb)
{
  return (EEPROM.read(lsb) + (EEPROM.read(lsb+1) << 8));
}

void Write_EEPROM()              // Ecriture des parametres dans l'EEPROM (seuleument si une valeur a change)
{
  WriteEEPROMByte( 1,EC_mode                   );
  WriteEEPROMint ( 2,EC_delais                 );
  WriteEEPROMByte( 4,EC_duree_heure            );
  WriteEEPROMByte( 5,EC_duree_minute           );
  WriteEEPROMByte( 6,EC_duree_seconde          );
  WriteEEPROMint ( 7,EC_duree_milliseconde     );
  WriteEEPROMByte( 9,EC_increment_heure        );
  WriteEEPROMByte(10,EC_increment_minute       );
  WriteEEPROMByte(11,EC_increment_seconde      );
  WriteEEPROMint (12,EC_increment_milliseconde );
  WriteEEPROMByte(14,EC_intervalle_heure       );
  WriteEEPROMByte(15,EC_intervalle_minute      );
  WriteEEPROMByte(16,EC_intervalle_seconde     );
  WriteEEPROMint (17,EC_intervalle_milliseconde);
  WriteEEPROMint (19,EC_nombre                 );
  WriteEEPROMByte(23,LCD_jour                  );
  WriteEEPROMByte(24,LCD_lumi                  );
  WriteEEPROMByte(25,LCD_veille_minute         );
  WriteEEPROMByte(26,LCD_veille_seconde        );
  WriteEEPROMByte(27,SLR_prefocus              );
  WriteEEPROMint (28,SLR_pause_mini_milliseconde);
  WriteEEPROMByte(30,SLR_verr_mirroir          );
}

void WriteEEPROMint(byte lsb, int val)
{
  WriteEEPROMByte(lsb,(val & 255));
  WriteEEPROMByte(lsb+1,((val >> 8) & 255));
}

void WriteEEPROMByte(byte lsb, byte val)
{
  if (EEPROM.read(lsb) != val)
  {
    EEPROM.write(lsb, val);
  }
}

void FormatEEPROM()              // Initialisation de l'EEPROM
{  
  WriteEEPROMByte(0, EEPROM_VERSION);
  Write_EEPROM();
}
