boolean submenu_Test()
{
  tft.fillRect(0,0,160,128,ST7735_BLACK);
  
  tft.drawstring_P(13,0,PSTR("Focus"));
  tft.drawstring_P(13,8,PSTR("Prise de vue"));
  tft.drawstring_P(13,16,PSTR("Les deux"));
  tft.drawstring_P(7,24,PSTR("Sortie"));
  
  boolean encpressed = true;
  
  boolean do_not_exit_main_menu = true;
  byte testmenupos = 0;
  byte maxmenu = 4-1;
  boolean test_focus = false;
  boolean test_shot  = false;

  drawfleche(testmenupos,0,0,8*maxmenu);
  
  drawtestpattern();

  while (do_not_exit_main_menu)
  {
    encpressed = ((digitalRead(EncPress) == LOW) &&
                  (! encpressed) && 
                  ((millis() - lastpress)>DeBounce));
                  
    checkveille();

    if (encpressed)
    {
      while (digitalRead(EncPress) == LOW)
      {
      }
      lastpress = millis();
      lastmove = lastpress;
      
      checkveille();

      switch (testmenupos) 
      {
        case 0:
          if (test_focus)
          {
            tft.fillRect(7,0,6,8,ST7735_BLACK);
            tft.fillRect(7,16,6,8,ST7735_BLACK);
            test_focus = false;
            digitalWrite(SLR_FOCUS , LOW);  
          } 
          else
          {
            tft.drawchar(7,0,CHKCHAR,fgcolor);
            test_focus = true;
            if (test_shot)
            {
              tft.drawchar(7,16,CHKCHAR,fgcolor);
            }
            digitalWrite(SLR_FOCUS , HIGH);  
          }
          break;
        case 1:
          if (test_shot)
          {
            tft.fillRect(7,8,6,8,ST7735_BLACK);
            tft.fillRect(7,16,6,8,ST7735_BLACK);
            test_shot = false;
            digitalWrite(SLR_SHOT , LOW);  
          } 
          else
          {
            tft.drawchar(7,8,CHKCHAR,fgcolor);
            test_shot = true;
            if (test_focus)
            {
              tft.drawchar(7,16,CHKCHAR,fgcolor);
            }
            digitalWrite(SLR_SHOT , HIGH);  
          }
          break;
        case 2:
          if (test_shot and test_focus)
          {
            tft.fillRect(7,0,6,24,ST7735_BLACK);
            test_shot = false;
            test_focus = false;
            digitalWrite(SLR_SHOT , LOW);  
            digitalWrite(SLR_FOCUS , LOW);  
          } 
          else
          {
            tft.drawchar(7,0,CHKCHAR,fgcolor);
            tft.drawchar(7,8,CHKCHAR,fgcolor);
            tft.drawchar(7,16,CHKCHAR,fgcolor);
            test_shot = true;
            test_focus = true;
            digitalWrite(SLR_FOCUS , HIGH);  
            digitalWrite(SLR_SHOT , HIGH);  
          }
          break;
        default:
          do_not_exit_main_menu = false;  
          // if nothing else matches, do the default
          // default is optional
      }      
    }
    else
    if (EncoderDiff != 0)
    {
      lastmove = millis();
      
      checkveille();
      
      if ((EncoderDiff == 1) && (testmenupos < maxmenu))
      {
        testmenupos++;
      }
      if ((EncoderDiff == -1) && (testmenupos > 0))
      {
        testmenupos--;
      }      
      
      drawfleche(testmenupos,0,0,maxmenu*8);
      
      EncoderDiff = 0;
    }
  }

  digitalWrite(EncRED , LOW);
  digitalWrite(EncGRN , LOW);
  digitalWrite(EncBLU , LOW);
  digitalWrite(SLR_FOCUS , LOW);  
  digitalWrite(SLR_SHOT  , LOW);  
  
  return false;
}

void drawtestpattern()
{
  byte x = 0;
  byte y = 40;
  
  uint16_t color;
  
  for (int i=0;i<=127;i++)
  {
    switch (i)
    {
      case ARRCHAR:
        color = ST7735_RED;
        break;
      case DOTCHAR:
        color = ST7735_GREEN;
        break;
      case DRPCHAR:
        color = ST7735_BLUE;
        break;
      case HRTCHAR:
        color = ST7735_RED;
        break;
      case LCKCHAR:
        color = ST7735_YELLOW;
        break;
      default:
        color = ST7735_WHITE;
    }
      
    
    tft.drawchar(x,y,i,color);
    x += 6;
    if (x + 5 >= tft.width()) 
    {
      y += 8;
      x  = 0;
    }    
  } 
  
  uint16_t R,V,B;
  
  for (int i=0;i<=159;i++)
  {
    R = map(i,0,159,0,0x1F)*0x800;
    V = map(i,0,159,0,0x3F)*0x20;
    B = map(i,0,159,0,0x1F);
    
    color = R+V+B;
    
    tft.drawVerticalLine(i,88,10,R);
    tft.drawVerticalLine(i,98,10,V);
    tft.drawVerticalLine(i,108,10,B);
    tft.drawVerticalLine(i,118,10,color);
  }  
}
